Attribute VB_Name = "intersection"
Global Const EPSILON = 0.000001


'Public Const Pi = 3.14159265358979
Global PI As Double

Global RADTODEG As Double
Global DEGTORAD As Double

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    x As Single
    y As Single
    Z As Single
End Type


'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.x = (P1.y * P2.Z) - (P1.Z * P2.y)
 P4.y = (P1.Z * P2.x) - (P1.x * P2.Z)
 P4.Z = (P1.x * P2.y) - (P1.y * P2.x)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.x * q.x + p.y * q.y + p.Z * q.Z
End Function

'Ajout de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional F As Double = 1) As Point3
 Dim P3 As Point3
 P3.x = P1.x + F * P2.x
 P3.y = P1.y + F * P2.y
 P3.Z = P1.Z + F * P2.Z
 VecAdd = P3
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.x = P1.x - P2.x
 VecSub.y = P1.y - P2.y
 VecSub.Z = P1.Z - P2.Z
End Function

Function Longueur(ByRef P1 As Point3) As Double
  Longueur = Sqr((P1.x ^ 2) + (P1.y ^ 2) + (P1.Z ^ 2))
End Function
' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(ByRef P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.x) ^ 2 + (P1.y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.x = P1.x / Norm
    VecteurUnitaire.y = P1.y / Norm
    VecteurUnitaire.Z = P1.Z / Norm
End Function

'----------------------------------------------------------------------------
' Calcul le point sur la courbe silhouette d'un tore

'---------------------------------------------------------------------------
Function PointSilhouette(Vecteur As Point3, GrandRayon As Double, Rayon As Double, Angle As Double) As Point3
Dim Normal As Point3
Dim PT_Silhouette As Point3
Dim PT_Centre As Point3
Dim PT_Int As Point3
Dim PT_Int2 As Point3
Dim Lg As Double
Dim AngleRad As Double

AngleRad = Angle * DEGTORAD

'Calcul du point de centre du cercle de la pastille
PT_Centre.x = GrandRayon * Cos(AngleRad)
PT_Centre.y = GrandRayon * Sin(AngleRad)
'If PT_Centre.X < EPSILON Then PT_Centre.X = 0

' Calcul de la normal en fonction de l'angle
Normal.x = -Sin(AngleRad)
Normal.y = Cos(AngleRad)

PT_Int = VecProd(Vecteur, Normal)
Lg = Longueur(PT_Int)

PT_Int.x = PT_Int.x / Lg
PT_Int.y = PT_Int.y / Lg
PT_Int.Z = PT_Int.Z / Lg

'calcul du point
PT_Silhouette = VecAdd(PT_Centre, PT_Int, -Rayon)
PointSilhouette = PT_Silhouette

End Function

'---------------------------------------------------------------------------
'----------------------------------------------------------------------------
' Calcul le point sur la courbe silhouette d'un tore Calcul rduit
'---------------------------------------------------------------------------
Function PointSilhouette2(Vecteur As Point3, GrandRayon As Double, Rayon As Double, Angle As Double) As Point3

Dim AngleRad As Double
Dim D As Double

AngleRad = Angle * DEGTORAD

D = Sqr((Vecteur.Z ^ 2 + (Vecteur.x * Cos(AngleRad)) ^ 2))
PointSilhouette2.x = GrandRayon * Cos(AngleRad) + Rayon * (Vecteur.Z * Cos(AngleRad) / D)
PointSilhouette2.y = GrandRayon * Sin(AngleRad) + Rayon * (Vecteur.Z * Sin(AngleRad) / D)
PointSilhouette2.Z = -Rayon * (Vecteur.x * Cos(AngleRad) / D)


End Function

'---------------------------------------------------------------------------



